﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Type particle(x As Float, y As Float, vel(2) As Double, acc(2) As Double, color As Int, grav(2) As Double, exploded As Boolean, explosion As List)
	Private timer1 As Timer
	Private fx As JFX
	Private c As Canvas
	Private fireworks_list As List 
	Private velocity(2) As Double
	Private explodedint As Int
	Private drawtext As String
	Private timeC As Int 
	Private txtColor As Int 
End Sub

'Particles = Enter the number of fireworks you want to fire.
'Explodedp = The particles that will created after explosen (recommended between 10-15)
'Can = The Canvas that will be drawn on.
'Text = Enter the text that will be shown on the top
Public Sub Initialize(Particles As Int, Explodedp As Int, Can As Canvas,Text As String)
	timer1.Initialize("timer1",16)
	c.Initialize("c")
	fireworks_list.Initialize

	c = Can
	c.ClearRect(0,0,c.Width,c.Height)
	
	velocity(0) = 0.002
	velocity(1) = 0.2
	explodedint = Explodedp
	drawtext = Text
	
	For i = 0 To Particles 'number of fireworks
		Dim p As particle
		p.Initialize
		p.explosion.Initialize

		p.x=(Rnd(0,c.Width))
		p.y=Rnd(c.Height,c.Height+200)
		p.vel = Array As Double(2,Rnd(8,18)*-1)
		p.acc = Array As Double(0,0)
		p.grav = Array As Double(0,0)
		p.color = fx.Colors.To32Bit(fx.Colors.ARGB(255,Rnd(0,255),Rnd(0,255),Rnd(0,255)))
		p.exploded = False 
		fireworks_list.Add(p)
	Next
End Sub

Public Sub Start
	timer1.Enabled = True
End Sub

Public Sub Stop
	timer1.Enabled = False
End Sub

Private Sub timer1_tick
	If fireworks_list.Size = 0 Then Return
	timeC=timeC+1
		
	For i = 0 To fireworks_list.Size - 1	
		Dim p As particle = fireworks_list.Get(i) 
		p.grav(1) = p.grav(1)+velocity(1)
		p.y = p.y+(p.vel(1))+p.grav(1)
		
		If p.exploded = True Then 
			For Each p2 As particle In p.explosion
				p2.grav = p.grav
				p2.x = p2.x+p2.vel(0)
				p2.y = p2.y+p2.vel(1)
			Next
		End If
		
		If Abs(p.grav(1)) >= Abs(p.vel(1)) And p.exploded = False Then 
			p.exploded = True
			For i = 0 To explodedint 'number of explosions particles
				Dim pin As particle
				pin.Initialize
				pin.x = p.x
				pin.y = p.y
				pin.vel(0) = Rnd(1,5)
				pin.vel(1) = Rnd(1,8)
				If i mod 2 = 0 Then 
					pin.vel(0) = pin.vel(0) * -1
					pin.vel(1) = pin.vel(1) - (Rnd(2,6))
				End If
				pin.color = p.color
				pin.grav = p.grav
				p.explosion.Add(pin)
			Next
		End If
		
		If p.y < 0 Or p.y > c.Height+400 Then
			p.explosion.Clear
			p.x=(Rnd(0,c.Width))
			p.y=Rnd(c.Height,c.Height+200)
			p.vel = Array As Double(2,Rnd(8,18)*-1)
			p.acc = Array As Double(0,0)
			p.grav = Array As Double(0,0)
			p.color = fx.Colors.To32Bit(fx.Colors.ARGB(255,Rnd(0,255),Rnd(0,255),Rnd(0,255)))
			p.exploded = False 
		End If
	Next
	drawfireworks
End Sub

Private Sub drawfireworks
	c.DrawRect(0,0,c.Width,c.Height,fx.Colors.Black,True,0)
	
	'draw text
	If timeC mod 10 = 0 Then 'text color update rate (every x frames)
		txtColor = fx.Colors.To32Bit(fx.Colors.RGB(Rnd(0,255),Rnd(0,255),Rnd(0,255)))
	End If
	c.drawtext(drawtext,c.Width/2,c.Height/6,fx.CreateFont("Arial",32,False,False),fx.Colors.From32Bit(txtColor),"CENTER") 
	
	'draw particles (fireworks)
	For Each p As particle In fireworks_list
		If p.exploded Then 'reached the highest point / now explode!
			For Each p2 As particle In p.explosion
				Dim alpha As Int = Min(Floor(255/(p.grav(1)*0.2)), 255) 'fade out
				Dim color() As Int = GetARGB(alpha,fx.Colors.From32Bit(p.color))
				c.DrawCircle(p2.x,p2.y,2dip,fx.Colors.ARGB(color(0),color(1),color(2),color(3)),True,0)
			Next
		Else 'if flying up	
			Dim dis As Int = (p.grav(1)*-1/2)
			c.DrawCircle(p.x,p.y,2dip,fx.Colors.From32Bit(p.color),True,0)	
			
			For i = 1 To 8 'draw tail to firework when flying up
				Dim color() As Int = GetARGB(100/i,fx.Colors.From32Bit(p.color))
				c.DrawCircle(p.x,p.y-(dis*i),2dip+(i*0.25),fx.Colors.ARGB(color(0),color(1),color(2),color(3)),True,0)
			Next									
		End If
	Next
End Sub

Private Sub GetARGB(alpha As Int, ColorValue As Paint) As Int()
    Dim Color As Int = fx.Colors.To32Bit(ColorValue)
    Dim res(4) As Int
    res(0) = alpha
    res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
    res(3) = Bit.And(Color, 0xff)
    Return res
End Sub